import asyncio
import numpy as np 
from .local_req_strategy import *
class ReqCheckerLocal:

    def __init__(self, rtu_config, data_ref, violations_queue, logger, case):
        self.LocalReqConfiguration = LocalReqConfiguration()
        
        if (case == "demkit"):
            #demkit_test_case = Demkit_Test_Case(rtu_config, data_ref, violations_queue, logger)
            #self.LocalReqConfiguration.add_check(demkit_test_case)

            demkit_case_1 = DEMKit_S1_Household_Grid_Balance(rtu_config, data_ref, violations_queue, logger)
            self.LocalReqConfiguration.add_check(demkit_case_1)

            demkit_case_2 = DEMKit_S2_Safety_Threshold_C(rtu_config, data_ref, violations_queue, logger)
            self.LocalReqConfiguration.add_check(demkit_case_2)

            demkit_case_3 = DEMKit_S3_Battery_Overcharge(rtu_config, data_ref, violations_queue, logger)
            self.LocalReqConfiguration.add_check(demkit_case_3)

            demkit_case_4 = DEMKit_S4_Feedin_Only_Generators(rtu_config, data_ref, violations_queue, logger)
            self.LocalReqConfiguration.add_check(demkit_case_4)

            demkit_case_5 = DEMKit_S5_Battery_Discharge(rtu_config, data_ref, violations_queue, logger)
            self.LocalReqConfiguration.add_check(demkit_case_5)
            
    
    async def check_requirements(self):
        await self.LocalReqConfiguration.run_checks()

# helper class 
# that allows to store requirement configurations and to execute all the checks in an configuration 
class LocalReqConfiguration: 
    def __init__(self):
        self.checks = []
    
    def add_check(self, check_strategy):
        self.checks.append(check_strategy)
        
    async def run_checks(self):
        for check_strategy in self.checks:
            await check_strategy.check()
           
 
      

