import asyncio
import json
import pandapower as pp
import time
import math
from .neighbourhood_req_strategy import *

import numpy as np 

class ReqCheckerNeighborhood:

    def __init__(self, border_regions, client_lms, vio_queue, logger, case ):
        self.NeighbourhoodReqConfiguration = NeighbourhoodReqConfiguration()

        if (case == "demkit"):
            #demkit_nm_test_case = DEMKit_NM_Test_Case(border_regions, client_lms, vio_queue, logger)
            #self.NeighbourhoodReqConfiguration.add_check(demkit_nm_test_case)

            demkit_nm_case_6 = DEMKit_S6_Registered_Feedin_Only(border_regions, client_lms, vio_queue, logger)
            self.NeighbourhoodReqConfiguration.add_check(demkit_nm_case_6)

            demkit_nm_case_7 = DEMKit_S7_Anomaly_Power_Surge(border_regions, client_lms, vio_queue, logger)
            self.NeighbourhoodReqConfiguration.add_check(demkit_nm_case_7)
            

    async def check_requirements(self, client_address_list):
        await self.NeighbourhoodReqConfiguration.run_checks()
    

# helper class 
# that allows to store requirement configurations and to execute all the checks in an configuration 
class NeighbourhoodReqConfiguration: 
    def __init__(self):
        self.checks = []
    
    def add_check(self, check_strategy):
        self.checks.append(check_strategy)
        
    async def run_checks(self):
        for check_strategy in self.checks:
            await check_strategy.check()
           