import csv
import time
import sys
from mosaikrtu.rtu_model import create_server, create_datablock, load_rtu



class Replay:

    def __init__(self):
        self.server = []
        self.datablocks = []
        self.configs = []
        self.scenario = []

    def load_scenario(self):
        print("Load scenario")
    
        self.configs.append(load_rtu("./data/DEMKit/House-1.xml"))
        self.configs.append(load_rtu("./data/DEMKit/House-4.xml"))
        self.configs.append(load_rtu("./data/DEMKit/House-8.xml"))
        self.configs.append(load_rtu("./data/DEMKit/Feeder.xml"))

        # choose 1,2,3 or 4
        attack = 1
        
        with open("./data/att_scenario_"+ str(attack)+"/CSV-House-1.csv", "r") as csv_file:
            csv_reader = csv.reader(csv_file, delimiter=";")
            self.scenario.append([])

            csv_reader.__next__()

            for row in csv_reader:
                self.scenario[0].append(row[0:12])
        
        with open("./data/att_scenario_"+ str(attack)+"/CSV-House-4.csv", "r") as csv_file:
            csv_reader = csv.reader(csv_file, delimiter=";")
            self.scenario.append([])

            csv_reader.__next__()

            for row in csv_reader:
                self.scenario[1].append(row[0:6])

        with open("./data/att_scenario_"+ str(attack)+"/CSV-House-8.csv", "r") as csv_file:
            csv_reader = csv.reader(csv_file, delimiter=";")
            self.scenario.append([])

            csv_reader.__next__()

            for row in csv_reader:
                self.scenario[2].append(row[0:12])

        with open("./data/att_scenario_"+ str(attack)+"/CSV-Feeder.csv", "r") as csv_file:
            csv_reader = csv.reader(csv_file, delimiter=";")
            self.scenario.append([])

            csv_reader.__next__()

            for row in csv_reader:
                self.scenario[3].append(row[0:2])

        for i in [0, 1, 2, 3]:
            self.datablocks.append(create_datablock(self.configs[i]))

        for i in [0, 1, 2, 3]:
            self.server.append(create_server(self.configs[i], self.datablocks[i]))

        print("Server created")

    def run_scenario(self, sleeptime):
        print("Start scenario.")

        for i in [0, 1, 2, 3]:
            self.server[i].start()
            print("Started server {}".format(i))


       
        y = 0
        while y < len(self.scenario[0]):
            print("Refreshing datasets")
            for i in [0, 1, 2, 3]:
                index_register = 0
                for value in self.scenario[i][y]:
                    if value != "":
                        config_item = list(self.configs[i]['registers'].values())[index_register]

                        self.datablocks[i].set(
                            config_item[0],
                            config_item[1],
                            value,
                            config_item[2]
                        )
                        index_register += 1

            time.sleep(sleeptime)

            y += 1

        time.sleep(10)

        print("No more data available, stopping server")

        for i in [0, 1, 2, 3]:
            self.server[i].stop()

        print("Servers stopped")


if __name__ == '__main__':

    print("starting scenario")

    replay = Replay()
    replay.load_scenario() 
    replay.run_scenario(3) 

    print("finished scenario.")
    time.sleep(10)
    sys.exit(0)